import {Permission} from "../stores/RoleStore";

type Target = {
    target_id: string,
    target_display_name: string,
    target_category?: string
}

export class ComponentPermissionGroup {
    actions: Array<Permission> = [];
    target: Target;

    constructor(target: Target) {
        this.target = target;
    }

    compare(a: ComponentPermissionGroup) {
        if (this.target.target_category === a.target.target_category) {
            if (a.actions.length - this.actions.length !== 0) {
                return a.actions.length - this.actions.length;
            }
            return (this.target.target_display_name || '').localeCompare(a.target.target_display_name || '');
        }
        return this.target.target_category?.localeCompare(a.target.target_category || "") || 0;
    }
}